*
* $Id: build_table.F,v 1.2 1995/08/29 13:28:22 zfiles Exp $
*
* $Log: build_table.F,v $
* Revision 1.2  1995/08/29 13:28:22  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : build_table
C     Purpose : Loop over all wafer elements and build a 
C               table of the closest elements to each 
C               line in the table.
C     
C
C     Modifications:
C
C
C
      subroutine build_table

      implicit none

#include "klmn/klmnseq/table.inc"
#include "klmn/klmnseq/wafer_n.inc"
#include "klmn/klmnseq/chamber_n.inc"      

      integer i_lines,j,k,iwaf,num_waf_temp

      real dist,dist_temp

      call build_rmin_rmax

      call init_table

      do 10,i_lines=1,nlines

         do 20,j=1,ntable_waf

            number_waf(j,i_lines)=-1
            dist_waf(j,i_lines)=100000.0

 20      continue

         do 30,j=1,nwaf

           if (level_waf(j).gt.cham_svx_level) goto 30
           
           call waf_dist(i_lines,j,dist)

           iwaf=j

           do 40,k=1,ntable_waf

             if (dist.lt.dist_waf(k,i_lines)) then

                dist_temp=dist_waf(k,i_lines)

                num_waf_temp=number_waf(k,i_lines)

                dist_waf(k,i_lines)=dist

                number_waf(k,i_lines)=iwaf

                dist=dist_temp

                iwaf=num_waf_temp

              endif

 40         continue

 30     continue

 10   continue


      return

      end

                


