*
* $Id: calc_res.F,v 1.2 1995/08/29 13:28:23 zfiles Exp $
*
* $Log: calc_res.F,v $
* Revision 1.2  1995/08/29 13:28:23  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : calc_res
C     Purpose : Calculate the residul and the error
C     
C
C     Modifications:
C
C
C


      subroutine calc_res(i,eta,veta)

      implicit none

      integer i
      real eta(5)
      real*8 veta(5,5)

#include "klmn/klmnseq/cleofitcom.inc"
#include "klmn/klmnseq/klmncm.inc"
#include "klmn/klmnseq/klmntrk.inc"
#include "klmn/klmnseq/klmnctrl.inc"

      real der(5),dpmin,dpmin0,dkappa
      real*8 sigma2trackd,dvd(5)
    
      integer part_type

      dkappa=0.0

      if (abs(eta(1)).lt.0.03) then 
         dkappa=eta(1)-0.03*sign(1.0,eta(1))
         eta(1)=eta(1)-dkappa
      endif

 
      if (itype(i).eq.1) then
         call cleoaxialder(eta(1),eta(3),eta(2),
     +          eta(5),eta(4),i,der,dpmin0)
      elseif (itype(i).eq.2) then
        call cleostereoder(eta(1),eta(3),eta(2),
     +          eta(5),eta(4),i,der,dpmin0)
      elseif (itype(i).eq.3) then
        dpmin0=eta(5)
        call cleocatder(eta(1),eta(3),eta(2),
     +          eta(5),eta(4),i,der)
      elseif (itype(i).eq.5) then
        dpmin0=eta(5)
        call cleochgdivder(eta(1),eta(3),eta(2),
     +          eta(5),eta(4),i,der)
      elseif (itype(i).eq.0) then
         res_s(i)=-999.0
         sigma2_s(i)=1.0
         goto 999
      elseif (itype(i).eq.4) then
         call cleosvxder(eta(1),eta(3),eta(2),eta(5),eta(4),
     +        w_org(1,i),u_hat(1,i),v_hat(1,i),
     +        der,dpmin0)
      else
         print *,'unknown hit type in klmn_add_hit:',itype(i)
      endif

      dpmin0=dpmin0+der(1)*dkappa
      eta(1)=eta(1)+dkappa

      dvd(1)=veta(1,1)*der(1)+veta(1,2)*der(2)+veta(1,3)*der(3)+
     +       veta(1,4)*der(4)+veta(1,5)*der(5)

      dvd(2)=veta(2,1)*der(1)+veta(2,2)*der(2)+veta(2,3)*der(3)+
     +       veta(2,4)*der(4)+veta(2,5)*der(5)

      dvd(3)=veta(3,1)*der(1)+veta(3,2)*der(2)+veta(3,3)*der(3)+
     +       veta(3,4)*der(4)+veta(3,5)*der(5)

      dvd(4)=veta(4,1)*der(1)+veta(4,2)*der(2)+veta(4,3)*der(3)+
     +       veta(4,4)*der(4)+veta(4,5)*der(5)

      dvd(5)=veta(5,1)*der(1)+veta(5,2)*der(2)+veta(5,3)*der(3)+
     +       veta(5,4)*der(4)+veta(5,5)*der(5)

      sigma2trackd=dvd(1)*der(1)+dvd(2)*der(2)+dvd(3)*der(3)+
     +             dvd(4)*der(4)+dvd(5)*der(5)

      res_s(i)=dpmin0-d(klmnctrl_part,i)
      sigma2_s(i)=sigma2trackd

999   continue
      return
      end












