*
* $Id: cham_int.F,v 1.3 1996/04/08 14:39:41 zfiles Exp $
*
* $Log: cham_int.F,v $
* Revision 1.3  1996/04/08 14:39:41  zfiles
* Improve diagnostic output
*
* Revision 1.2  1995/08/29  13:28:23  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : cham_int
C     Purpose : find if line passes throug a given volume
C     
C
C     Modifications:
C
C
C


      subroutine cham_int(icham,x1,x2,s_list,
     +            in_out_list,n_entries)

      implicit none

#include "klmn/klmnseq/chamber_n.inc"
#include "klmn/klmnseq/vol.inc"


      integer icham,in_out_list(10),n_entries
      real    x1(3),x2(3),s_list(10)
      real    xl1(3),xl2(3),vl(3),s1,s2
      integer i,in_out1,in_out2
     
      i=vol_num_cham(icham)


      call transform_to_local_cham(icham,x1,xl1) 
      call transform_to_local_cham(icham,x2,xl2) 


      if (vol_is(i).eq.is_box) then
         call box_intercept(s_list,in_out_list,n_entries,
     +       par_vol(i,1),par_vol(i,2),par_vol(i,3),xl1,xl2)
      elseif (vol_is(i).eq.is_tube) then
         call tube_intercept(s_list,in_out_list,n_entries,
     +       par_vol(i,1),par_vol(i,2),par_vol(i,3),xl1,xl2)
      elseif (vol_is(i).eq.is_pcon) then
         call pcon_intercept(s_list,in_out_list,n_entries,
     +       i,xl1,xl2)
      else
         print *,'wrong volume type in cham_int:',icham,i,vol_is(i)
      endif

      return

      end
     




















