*
* $Id: cone_int.F,v 1.2 1995/08/29 13:28:29 zfiles Exp $
*
* $Log: cone_int.F,v $
* Revision 1.2  1995/08/29 13:28:29  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : cone_int
C     Purpose : to find points where a straight line enters
C               and exits a cone.
C     
C
C     Modifications:
C
C
C
      subroutine cone_int(z1,r1,z2,r2,x1,v,s_list,n_inter)

      implicit none

      real z1,r1,z2,r2,x1(3),v(3),s_list(10)
      integer n_inter

      real*8 a,b,alpha,beta,q,s,z,r

      n_inter=0

      if (z1.ne.z2) then

        a=(r1-r2)/(z1-z2)
        b=r1-a*z1

        alpha=(x1(1)*v(1)+x1(2)*v(2)-a*v(3)*(a*x1(3)+b))/
     +           (v(1)**2+v(2)**2-(a*v(3))**2)

        beta=(x1(1)**2+x1(2)**2-(a*x1(3)+b)**2)/
     +           (v(1)**2+v(2)**2-(a*v(3))**2)


        q=alpha**2-beta

        if (q.le.0.0) goto 999

        s=-alpha+sqrt(q)
        z=x1(3)+v(3)*s
        if (z.gt.min(z1,z2).and.z.lt.max(z1,z2)) then
          n_inter=n_inter+1
          s_list(n_inter)=s
        endif

        s=-alpha-sqrt(q)
        z=x1(3)+v(3)*s
        if (z.gt.min(z1,z2).and.z.lt.max(z1,z2)) then
          n_inter=n_inter+1
          s_list(n_inter)=s
        endif

      else

        if (v(3).eq.0.0) goto 999

        s=-(x1(3)-z1)/v(3)

        r=sqrt((x1(1)+v(1)*s)**2+(x1(2)+v(2)*s)**2)

        if (r.gt.min(r1,r2).and.r.lt.max(r1,r2)) then
          n_inter=n_inter+1
          s_list(n_inter)=s
        endif
   
      endif

999   continue

      return

      end





