*
* $Id: in_quad.F,v 1.2 1995/08/29 13:28:37 zfiles Exp $
*
* $Log: in_quad.F,v $
* Revision 1.2  1995/08/29 13:28:37  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : in_quad
C     Purpose : To check is straight line goes through a 
C               quad.
C     
C
C     Modifications:
C
C
C
      subroutine in_quad(x,v,x1,x2,x3,x4,s_list,n_enter)

      implicit none

      real  x(3),v(3)
      real*8 x1(3),x2(3),x3(3),x4(3)
      real s_list(10)

      integer n_enter

      real*8 n(3),up(3),upp(3),a,b,xc,yc,s,x_int(3)

      real*8 s1,s2,r,u,t,nv

      up(1)=x2(1)-x1(1)
      up(2)=x2(2)-x1(2)
      up(3)=x2(3)-x1(3)

      upp(1)=x3(1)-x1(1)
      upp(2)=x3(2)-x1(2)
      upp(3)=x3(3)-x1(3)

      t=up(1)*up(1)+up(2)*up(2)+up(3)*up(3)
      r=upp(1)*upp(1)+upp(2)*upp(2)+upp(3)*upp(3)

      u=upp(1)*up(1)+upp(2)*up(2)+upp(3)*up(3)


      n(1)=up(2)*upp(3)-up(3)*upp(2)
      n(2)=up(3)*upp(1)-up(1)*upp(3)
      n(3)=up(1)*upp(2)-up(2)*upp(1)


      nv=n(1)*dble(v(1))+n(2)*dble(v(2))+n(3)*dble(v(3))

      if (nv.eq.0.0D0) goto 999

      s=(n(1)*(x1(1)-dble(x(1)))+n(2)*(x1(2)-dble(x(2)))+
     +  n(3)*(x1(3)-dble(x(3))))/nv

      x_int(1)=dble(x(1))-x1(1)+s*dble(v(1))
      x_int(2)=dble(x(2))-x1(2)+s*dble(v(2))
      x_int(3)=dble(x(3))-x1(3)+s*dble(v(3))

      s1=up(1)*x_int(1)+up(2)*x_int(2)+up(3)*x_int(3)
      s2=upp(1)*x_int(1)+upp(2)*x_int(2)+upp(3)*x_int(3)
    

      xc=(r*s1-u*s2)/(t*r-u*u)
      yc=(-u*s1+t*s2)/(t*r-u*u)

      if (xc.lt.0.0D0.or.yc.lt.0.0D0) return

      s1=up(1)*(x4(1)-x1(1))+up(2)*(x4(2)-x1(2))+
     +   up(3)*(x4(3)-x1(3))

      s2=upp(1)*(x4(1)-x1(1))+upp(2)*(x4(2)-x1(2))+
     +   upp(3)*(x4(3)-x1(3))

      a=(r*s1-u*s2)/(t*r-u*u)
      b=(-u*s1+t*s2)/(t*r-u*u)


      if (a.lt.0.0D0.or.b.lt.0.0D0) then
        print *,'Problems in in_quad.F'

        print *,'x :',x(1),x(2),x(3)
        print *,'v :',v(1),v(2),v(3)
        print *,'x1:',x1(1),x1(2),x1(3)
        print *,'x2:',x2(1),x2(2),x2(3)
        print *,'x3:',x3(1),x3(2),x3(3)
        print *,'x4:',x4(1),x4(2),x4(3)
        print *,'s,xc,yc,a,b:',s,xc,yc,a,b

      endif


      if (((b*xc.lt.a*yc).and.((1.0+xc*(b-1.0)/a).gt.yc)).or.
     +    ((b*xc.ge.a*yc).and.((1.0+yc*(a-1.0)/b).gt.xc))) then
         
        n_enter=n_enter+1

        s_list(n_enter)=s

      endif

999   continue

      return

      end








