*
* $Id: klmn_init.F,v 1.2 1995/08/29 13:28:45 zfiles Exp $
*
* $Log: klmn_init.F,v $
* Revision 1.2  1995/08/29 13:28:45  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : klmn_init
C     Purpose : This routine initializes the track information eta0,deta
C               and veta before the fit
C     
C
C     Modifications:
C
C
C


      subroutine klmn_init(eta0,deta,vetastar)

      implicit none

      real eta0(5),deta(5)
      real*8 vetastar(5,5),v_start_d(5,5)

#include "klmn/klmnseq/cleofitcom.inc"
#include "klmn/klmnseq/klmncm.inc"
#include "klmn/klmnseq/klmntrk.inc"
#include "klmn/klmnseq/mater_stop.inc"
#include "klmn/klmnseq/klmn_misc.inc"
#include "klmn/klmnseq/klmnctrl.inc"

      integer i,j

      klmnctrl_in=+1
      klmnctrl_chisq=.true.

      call vzero(deta,5)

      eta0(1)=k_start
      eta0(3)=d0_start
      eta0(2)=phi_start
      eta0(5)=z_start
      eta0(4)=t_start

      do 3,i=1,5
        do 4,j=1,5
          v_start_d(i,j)=v_start(i,j)
4     continue
3     continue

      if (start_type.eq.0) then
        call vzero(vetastar,2*25)
        vetastar(1,1)=0.5
        vetastar(2,2)=0.01
        vetastar(3,3)=0.01
        vetastar(4,4)=5.0
        vetastar(5,5)=5.0
        chisq=0.0
        call t_to_t_c(eta0,eta0,
     +          xo_start-x(1),yo_start-y(1),zo_start,1)
      elseif(start_type.eq.1) then
        call klmn_trans(xo_start,yo_start,x(1),y(1),
     +          eta0,deta,v_start_d,eta0,deta,vetastar)
        chisq=chisq_start
      else
        print *,'Wrong start type!'
      endif        

      If (abs(eta0(1)).lt.0.03) then
        eta0(1)=0.03*sign(1.0,eta0(1))
      endif


      return

      end









