*
* $Id: klmn_smooth_d.F,v 1.2 1995/08/29 13:28:49 zfiles Exp $
*
* $Log: klmn_smooth_d.F,v $
* Revision 1.2  1995/08/29 13:28:49  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : klmn_smooth_d
C     Purpose : To perform the smmothing.
C     
C
C     Modifications:
C
C
C
      subroutine klmn_smooth_d(i,eta0,deta,vetastar,eta,veta)

      implicit none

      integer i

      real eta0(5),deta(5),eta(5)
      real*8 vetastar(5,5)
      real*8 veta(5,5)

#include "klmn/klmnseq/cleofitcom.inc"
#include "klmn/klmnseq/klmncm.inc"
#include "klmn/klmnseq/klmn_par.inc"

      real*8 eta1(5),eta2(5),ieta(5)
      real*8 i1(5,5),i2(5,5),itot(5,5)
      

      eta1(1)=eta0(1)+deta(1)
      eta1(2)=eta0(2)+deta(2)
      eta1(3)=eta0(3)+deta(3)
      eta1(4)=eta0(4)+deta(4)
      eta1(5)=eta0(5)+deta(5)

      eta2(1) = eta_s(1,i)
      eta2(2) = eta_s(2,i)
      eta2(3) = eta_s(3,i)
      eta2(4) = eta_s(4,i)
      eta2(5) = eta_s(5,i)


      if (abs(eta1(2)-eta2(2)).ge.klmn_pi) then
        if (eta1(2).lt.eta2(2)) then
           eta2(2)=eta2(2)-klmn_twopi
        else
           eta1(2)=eta1(2)-klmn_twopi
        endif
      endif 

      call invert_sym_d(vetastar,i1)

      call invert_sym_d(veta_s(1,1,i),i2)


      itot(1,1)=i1(1,1)+i2(1,1)
      itot(1,2)=i1(1,2)+i2(1,2)
      itot(1,3)=i1(1,3)+i2(1,3)
      itot(1,4)=i1(1,4)+i2(1,4)
      itot(1,5)=i1(1,5)+i2(1,5)

      itot(2,1)=itot(1,2)
      itot(2,2)=i1(2,2)+i2(2,2)
      itot(2,3)=i1(2,3)+i2(2,3)
      itot(2,4)=i1(2,4)+i2(2,4)
      itot(2,5)=i1(2,5)+i2(2,5)

      itot(3,1)=itot(1,3)
      itot(3,2)=itot(2,3)
      itot(3,3)=i1(3,3)+i2(3,3)
      itot(3,4)=i1(3,4)+i2(3,4)
      itot(3,5)=i1(3,5)+i2(3,5)

      itot(4,1)=itot(1,4)
      itot(4,2)=itot(2,4)
      itot(4,3)=itot(3,4)
      itot(4,4)=i1(4,4)+i2(4,4)
      itot(4,5)=i1(4,5)+i2(4,5)

      itot(5,1)=itot(1,5)
      itot(5,2)=itot(2,5)
      itot(5,3)=itot(3,5)
      itot(5,4)=itot(4,5)
      itot(5,5)=i1(5,5)+i2(5,5)



      call invert_sym_d(itot,veta)


      ieta(1)=
     +         i1(1,1)*eta1(1)+i2(1,1)*eta2(1)+
     +         i1(2,1)*eta1(2)+i2(2,1)*eta2(2)+
     +         i1(3,1)*eta1(3)+i2(3,1)*eta2(3)+
     +         i1(4,1)*eta1(4)+i2(4,1)*eta2(4)+
     +         i1(5,1)*eta1(5)+i2(5,1)*eta2(5)

      ieta(2)=
     +         i1(1,2)*eta1(1)+i2(1,2)*eta2(1)+
     +         i1(2,2)*eta1(2)+i2(2,2)*eta2(2)+
     +         i1(3,2)*eta1(3)+i2(3,2)*eta2(3)+
     +         i1(4,2)*eta1(4)+i2(4,2)*eta2(4)+
     +         i1(5,2)*eta1(5)+i2(5,2)*eta2(5)

      ieta(3)=
     +         i1(1,3)*eta1(1)+i2(1,3)*eta2(1)+
     +         i1(2,3)*eta1(2)+i2(2,3)*eta2(2)+
     +         i1(3,3)*eta1(3)+i2(3,3)*eta2(3)+
     +         i1(4,3)*eta1(4)+i2(4,3)*eta2(4)+
     +         i1(5,3)*eta1(5)+i2(5,3)*eta2(5)

      ieta(4)=
     +         i1(1,4)*eta1(1)+i2(1,4)*eta2(1)+
     +         i1(2,4)*eta1(2)+i2(2,4)*eta2(2)+
     +         i1(3,4)*eta1(3)+i2(3,4)*eta2(3)+
     +         i1(4,4)*eta1(4)+i2(4,4)*eta2(4)+
     +         i1(5,4)*eta1(5)+i2(5,4)*eta2(5)

      ieta(5)=
     +         i1(1,5)*eta1(1)+i2(1,5)*eta2(1)+
     +         i1(2,5)*eta1(2)+i2(2,5)*eta2(2)+
     +         i1(3,5)*eta1(3)+i2(3,5)*eta2(3)+
     +         i1(4,5)*eta1(4)+i2(4,5)*eta2(4)+
     +         i1(5,5)*eta1(5)+i2(5,5)*eta2(5)


      eta(1)= sngl(
     +        veta(1,1)*ieta(1)+veta(2,1)*ieta(2)+
     +        veta(3,1)*ieta(3)+veta(4,1)*ieta(4)+
     +        veta(5,1)*ieta(5) )

      eta(2)= sngl(
     +        veta(1,2)*ieta(1)+veta(2,2)*ieta(2)+
     +        veta(3,2)*ieta(3)+veta(4,2)*ieta(4)+
     +        veta(5,2)*ieta(5) )

      eta(3)= sngl(
     +        veta(1,3)*ieta(1)+veta(2,3)*ieta(2)+
     +        veta(3,3)*ieta(3)+veta(4,3)*ieta(4)+
     +        veta(5,3)*ieta(5) )

      eta(4)= sngl(
     +        veta(1,4)*ieta(1)+veta(2,4)*ieta(2)+
     +        veta(3,4)*ieta(3)+veta(4,4)*ieta(4)+
     +        veta(5,4)*ieta(5) )

      eta(5)= sngl(
     +        veta(1,5)*ieta(1)+veta(2,5)*ieta(2)+
     +        veta(3,5)*ieta(3)+veta(4,5)*ieta(4)+
     +        veta(5,5)*ieta(5) )


      return

      end









