*
* $Id: line_rmin_rmax.F,v 1.2 1995/08/29 13:28:51 zfiles Exp $
*
* $Log: line_rmin_rmax.F,v $
* Revision 1.2  1995/08/29 13:28:51  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : line_rmin_rmax
C     Purpose : Find extreme values of a line segment.
C     
C
C     Modifications:
C
C
C
      subroutine line_rmin_rmax(x1,y1,vx,vy,rmin,rmax,
     +           phi_min,phi_max)

      implicit none

#include "klmn/klmnseq/klmn_par.inc"

      real x1,y1,vx,vy,rmin,rmax,zmin,zmax
      real phi_min,phi_max,phi1,phi2

      real r1,r2,s

      phi1=atan2(x1,y1)
      phi2=atan2(x1+vx,y1+vy)


      if (phi1-phi2.lt.-klmn_pi) phi1=phi1+klmn_twopi
      if (phi2-phi1.lt.-klmn_pi) phi2=phi2+klmn_twopi

      phi_min=min(phi1,phi2)
      phi_max=max(phi1,phi2)

      if (phi_max-phi_min.gt.2.0) then
         print *,'Potential problem in line_rmin_rmax:'
         print *,'x1,y1,vx,vy:',x1,y1,vx,vy
         print *,'phi1,phi2,phi_min,phi_max:',
     +            phi1,phi2,phi_min,phi_max
      endif

      r1=sqrt(x1**2+y1**2)
      r2=sqrt((x1+vx)**2+(y1+vy)**2)

      rmin=min(r1,r2)
      rmax=max(r1,r2)


      if (vx**2+vy**2.eq.0.0) goto 999

      s=-(x1*vx+y1*vy)/(vx**2+vy**2)

      rmin=min(rmin,sqrt((x1+s*vx)**2+(y1+s*vy)**2))

999   continue

      return

      end

