*
* $Id: para_rmin_rmax.F,v 1.2 1995/08/29 13:28:53 zfiles Exp $
*
* $Log: para_rmin_rmax.F,v $
* Revision 1.2  1995/08/29 13:28:53  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : para_rmin_rmax
C     Purpose : Find the extreme values of a para volume.
C     
C
C     Modifications:
C
C
C
      subroutine para_rmin_rmax(ivol,iwaf,rmin,rmax,
     +       phi_min,phi_max,zmin,zmax)


      implicit none

#include "klmn/klmnseq/wafer_n.inc"
#include "klmn/klmnseq/vol.inc"
#include "klmn/klmnseq/klmn_par.inc"


      real rmin,rmax,qrmax,qrmin
      real zmin,zmax,qzmax,qzmin
      real phi_min,phi_max,lphi_min,lphi_max

      integer ivol,iwaf      



      real phi,theta

      real  v(3)
      real xg1(3),xg2(3),xg3(3),xg4(3),xg5(3)
      real xg6(3),xg7(3),xg8(3)
      real x1(3),x2(3),x3(3),x4(3),x5(3)
      real x6(3),x7(3),x8(3)

      real dx,dy,dz
      
      phi_min=16.3
      phi_max=-6.3
      rmin=10000.0
      rmax=0.0

      zmin=10000.0
      zmax=-10000.0

      if (par_vol(ivol,4).ne.0.0) then
         print *,'alpha is not zero! Error!'
      endif

      phi=par_vol(ivol,6)*0.017453292
      theta=par_vol(ivol,5)*0.017453292

      dx=par_vol(ivol,1)
      dy=par_vol(ivol,2)
      dz=par_vol(ivol,3)


      x1(1)=dx
      x1(2)=sin(phi)*tan(theta)*dz-dy
      x1(3)=dz

      x2(1)=dx
      x2(2)=sin(phi)*tan(theta)*dz+dy
      x2(3)=dz

      x3(1)=dx
      x3(2)=-sin(phi)*tan(theta)*dz-dy
      x3(3)=-dz

      x4(1)=dx
      x4(2)=-sin(phi)*tan(theta)*dz+dy
      x4(3)=-dz


      x5(1)=-dx
      x5(2)=sin(phi)*tan(theta)*dz-dy
      x5(3)=dz

      x6(1)=-dx
      x6(2)=sin(phi)*tan(theta)*dz+dy
      x6(3)=dz

      x7(1)=-dx
      x7(2)=-sin(phi)*tan(theta)*dz-dy
      x7(3)=-dz

      x8(1)=-dx
      x8(2)=-sin(phi)*tan(theta)*dz+dy
      x8(3)=-dz


      call transform(iwaf,x1,xg1)     
      call transform(iwaf,x2,xg2)     
      call transform(iwaf,x3,xg3)     
      call transform(iwaf,x4,xg4)     
      call transform(iwaf,x5,xg5)     
      call transform(iwaf,x6,xg6)     
      call transform(iwaf,x7,xg7)     
      call transform(iwaf,x8,xg8)     

      call quad_rmin_rmax(xg1,xg2,xg3,xg4,qrmin,qrmax,
     +      lphi_min,lphi_max,qzmin,qzmax)

      zmin=min(zmin,qzmin)
      zmax=max(zmax,qzmax)

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)
      rmin=min(rmin,qrmin)
      rmax=max(rmax,qrmax)

      call quad_rmin_rmax(xg5,xg6,xg7,xg8,qrmin,qrmax,
     +      lphi_min,lphi_max,qzmin,qzmax)

      zmin=min(zmin,qzmin)
      zmax=max(zmax,qzmax)
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)
      rmin=min(rmin,qrmin)
      rmax=max(rmax,qrmax)

      call quad_rmin_rmax(xg1,xg3,xg5,xg7,qrmin,qrmax,
     +      lphi_min,lphi_max,qzmin,qzmax)

      zmin=min(zmin,qzmin)
      zmax=max(zmax,qzmax)
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)
      rmin=min(rmin,qrmin)
      rmax=max(rmax,qrmax)

      call quad_rmin_rmax(xg2,xg4,xg6,xg8,qrmin,qrmax,
     +      lphi_min,lphi_max,qzmin,qzmax)

      zmin=min(zmin,qzmin)
      zmax=max(zmax,qzmax)
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif


      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)
      rmin=min(rmin,qrmin)
      rmax=max(rmax,qrmax)

      call quad_rmin_rmax(xg1,xg2,xg5,xg6,qrmin,qrmax,
     +      lphi_min,lphi_max,qzmin,qzmax)

      zmin=min(zmin,qzmin)
      zmax=max(zmax,qzmax)
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)
      rmin=min(rmin,qrmin)
      rmax=max(rmax,qrmax)

      call quad_rmin_rmax(xg3,xg4,xg7,xg8,qrmin,qrmax,
     +      lphi_min,lphi_max,qzmin,qzmax)

      zmin=min(zmin,qzmin)
      zmax=max(zmax,qzmax)
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)
      rmin=min(rmin,qrmin)
      rmax=max(rmax,qrmax)

      if (phi_min.gt.klmn_twopi) then
             phi_min=phi_min-klmn_twopi
             phi_max=phi_max-klmn_twopi
      endif

      if (phi_min.gt.klmn_twopi) then
             phi_min=phi_min-klmn_twopi
             phi_max=phi_max-klmn_twopi
      endif


      if (phi_max-phi_min.gt.2.0) then 
         print *,'problem in para_rmin_rmax'
         print *,'phi_max,phi_min:',phi_max,phi_min
      endif


      return

      end









