*
* $Id: pcon_intercept.F,v 1.2 1995/08/29 13:28:53 zfiles Exp $
*
* $Log: pcon_intercept.F,v $
* Revision 1.2  1995/08/29 13:28:53  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : pcon_intercept
C     Purpose : Find the intercept of a straight line
C               with a poly cone.
C     
C
C     Modifications:
C
C
C

      subroutine pcon_intercept(s_list,in_out_list,n_inter,
     +                             ivol,x1,x2)


      implicit none

#include "klmn/klmnseq/vol.inc"

      integer in_out_list(10),n_inter,n_inter_cone
      real s_list(10)
      integer n_inter_temp

      real s_list_temp(10),s_list_cone(10)

      real s1,s2,x1(3),x2(3)

      real r1,r2      

      real s(4),in_out(4),vxy2,vx,q2,smin,lmin

      logical bubble
   
      integer j,i,ivol,nz

      real v(3)

      n_inter_temp=0
      n_inter=0

      v(1)=x2(1)-x1(1)
      v(2)=x2(2)-x1(2)
      v(3)=x2(3)-x1(3)
 
      if (par_vol(ivol,2).lt.359.0) then
         print *,'Fractions of pcon is not yet implemented!'
      endif
      
      if (abs(par_vol(ivol,3)*3+3-npar_vol(ivol)).gt.0.1) then
         print *,'Paramter counting is wrong!'
      endif

      nz=nint(par_vol(ivol,3))

      call cone_int(par_vol(ivol,4),par_vol(ivol,5),
     +              par_vol(ivol,4),par_vol(ivol,6),
     +              x1,v,s_list_cone,n_inter_cone)
      do 10,j=1,n_inter_cone
        n_inter_temp=n_inter_temp+1
        s_list_temp(n_inter_temp)=s_list_cone(j)
10    continue


      do 20,i=1,nz-1


        call cone_int(par_vol(ivol,i*3+1),par_vol(ivol,i*3+2),
     +              par_vol(ivol,i*3+4),par_vol(ivol,i*3+5),
     +              x1,v,s_list_cone,n_inter_cone)
      do 21,j=1,n_inter_cone
        n_inter_temp=n_inter_temp+1
        s_list_temp(n_inter_temp)=s_list_cone(j)
21    continue

        call cone_int(par_vol(ivol,i*3+1),par_vol(ivol,i*3+3),
     +              par_vol(ivol,i*3+4),par_vol(ivol,i*3+6),
     +              x1,v,s_list_cone,n_inter_cone)
      do 22,j=1,n_inter_cone
        n_inter_temp=n_inter_temp+1
        s_list_temp(n_inter_temp)=s_list_cone(j)
c        print *,s_list_temp(n_inter_temp)
22    continue
        
20    continue       

      call cone_int(par_vol(ivol,3*nz+1),par_vol(ivol,nz*3+2),
     +              par_vol(ivol,3*nz+1),par_vol(ivol,nz*3+3),
     +              x1,v,s_list_cone,n_inter_cone)
      do 30,j=1,n_inter_cone
        n_inter_temp=n_inter_temp+1
        s_list_temp(n_inter_temp)=s_list_cone(j)
30    continue

      if (mod(n_inter_temp,2).ne.0) then
         print *,'n_inter_temp:',n_inter_temp
      endif 
 
40    bubble=.false.

      do 50,i=1,n_inter_temp-1     
        if (s_list_temp(i).gt.s_list_temp(i+1)) then
          bubble=.true.
          call swapr(s_list_temp(i),s_list_temp(i+1))
        endif
50    continue

      if (bubble) goto 40

c     odd is in, even is out

      do 60,i=1,n_inter_temp
        if (s_list_temp(i).lt.1.0
     +             .and.s_list_temp(i).gt.0.0) then
          n_inter=n_inter+1
          s_list(n_inter)=s_list_temp(i)
          if (mod(i,2).eq.0) then
            in_out_list(n_inter)=-1
          else
            in_out_list(n_inter)=1
          endif 
        endif
60    continue


      return

      end









