*
* $Id: pgon_intercept.F,v 1.2 1995/08/29 13:28:54 zfiles Exp $
*
* $Log: pgon_intercept.F,v $
* Revision 1.2  1995/08/29 13:28:54  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : pgon_intercept
C     Purpose : Find intercept of a straight line with
C               the pgon 
C     
C
C     Modifications:
C
C
C

      subroutine pgon_intercept(s_list,in_out_list,n_inter,
     +                             ivol,x,xto)


      implicit none

#include "klmn/klmnseq/vol.inc"

      integer in_out_list(10),n_inter,n_inter_plane
      real s_list(10)

      real s_list_plane(10)

      real  x(3),xto(3)

      real*8 rmin,rmax,rmin1,rmin2,rmax1,rmax2,z1,z2,z
      real*8 phi,phi1,dphi

      real invcos

      integer npdv    

      real*8 s(4),in_out(4),vxy2,vx,q2,smin,lmin

      logical bubble
   
      integer j,i,ivol,nz,n_old

      real  v(3)
      real*8 x1(3),x2(3),x3(3),x4(3)

      n_inter_plane=0
    
      n_inter=0

      v(1)=xto(1)-x(1)
      v(2)=xto(2)-x(2)
      v(3)=xto(3)-x(3)
 
      
      if (abs(par_vol(ivol,4)*3+4-npar_vol(ivol)).gt.0.1) then
         print *,'In pgon_intercept'
         print *,'Paramter counting is wrong!'
      endif

      phi1=par_vol(ivol,1)*0.017453292
      dphi=par_vol(ivol,2)*0.017453292
      npdv=nint(par_vol(ivol,3))
      nz=nint(par_vol(ivol,4))
      phi=dphi/npdv

c     First do the ends.

      z=par_vol(ivol,5)
      rmin=par_vol(ivol,6)
      rmax=par_vol(ivol,7)

      if (rmin.eq.rmax) goto 6

      if (rmin.lt.0.001) then
        print *,'In pgon_intercept'
        print *,'rmin to small:',rmin
        rmin=0.001
      endif

      invcos=1.0/cos(phi/2)

      do 8,j=1,npdv

        x1(1)=cos((j-1)*phi+phi1)*rmin*invcos
        x1(2)=sin((j-1)*phi+phi1)*rmin*invcos
        x1(3)=z

        x2(1)=cos((j)*phi+phi1)*rmin*invcos
        x2(2)=sin((j)*phi+phi1)*rmin*invcos
        x2(3)=z

        x3(1)=cos((j-1)*phi+phi1)*rmax*invcos
        x3(2)=sin((j-1)*phi+phi1)*rmax*invcos
        x3(3)=z

        x4(1)=cos((j)*phi+phi1)*rmax*invcos
        x4(2)=sin((j)*phi+phi1)*rmax*invcos
        x4(3)=z

        call in_quad(x,v,x1,x2,x3,x4,s_list_plane,n_inter_plane)

8     continue      

6     continue 


      z=par_vol(ivol,(nz-1)*3+5)
      rmin=par_vol(ivol,(nz-1)*3+6)
      rmax=par_vol(ivol,(nz-1)*3+7)

      if (rmin.eq.rmax) goto 9

      if (rmin.lt.0.001) then
        print *,'In pgon_intercept'
        print *,'rmin to small:',rmin
        rmin=0.001
      endif

      do 7,j=1,npdv

        x1(1)=cos((j-1)*phi+phi1)*rmin*invcos
        x1(2)=sin((j-1)*phi+phi1)*rmin*invcos
        x1(3)=z

        x2(1)=cos((j)*phi+phi1)*rmin*invcos
        x2(2)=sin((j)*phi+phi1)*rmin*invcos
        x2(3)=z

        x3(1)=cos((j-1)*phi+phi1)*rmax*invcos
        x3(2)=sin((j-1)*phi+phi1)*rmax*invcos
        x3(3)=z

        x4(1)=cos((j)*phi+phi1)*rmax*invcos
        x4(2)=sin((j)*phi+phi1)*rmax*invcos
        x4(3)=z

        call in_quad(x,v,x1,x2,x3,x4,s_list_plane,n_inter_plane)

7     continue      


c     Now do the main areas

9     continue


      do 10,i=1,nz-1

        z1=par_vol(ivol,2+i*3)
        z2=par_vol(ivol,5+i*3)
        rmin1=par_vol(ivol,3+i*3)
        rmin2=par_vol(ivol,6+i*3)
        rmax1=par_vol(ivol,4+i*3)
        rmax2=par_vol(ivol,7+i*3)

        if (rmin1.lt.0.001) then
          print *,'In pgon_intercept'
          print *,'rmin1 to small:',rmin1
          rmin1=0.001
        endif

        if (rmin2.lt.0.001) then
          print *,'In pgon_intercept'
          print *,'rmin2 to small:',rmin2
          rmin2=0.001
        endif


        if (z1.eq.z2) then
          PRint *,'z1=z2 not implemented in pgon_intercept;'
        endif

        if (dphi.lt.359.0) then

          x1(1)=cos(phi1)*rmin1*invcos
          x1(2)=sin(phi1)*rmin1*invcos
          x1(3)=z1
          
          x2(1)=cos(phi1)*rmin2*invcos
          x2(2)=sin(phi1)*rmin2*invcos
          x2(3)=z2
          
          x3(1)=cos(phi1)*rmax1*invcos
          x3(2)=sin(phi1)*rmax1*invcos
          x3(3)=z1
          
          x4(1)=cos(phi1)*rmax2*invcos
          x4(2)=sin(phi1)*rmax2*invcos
          x4(3)=z2

          n_old=n_inter_plane

          call in_quad(x,v,x1,x2,x3,x4,s_list_plane,n_inter_plane)



          
          x1(1)=cos(phi1+dphi)*rmin1*invcos
          x1(2)=sin(phi1+dphi)*rmin1*invcos
          x1(3)=z1
          
          x2(1)=cos(phi1+dphi)*rmin2*invcos
          x2(2)=sin(phi1+dphi)*rmin2*invcos
          x2(3)=z2
          
          x3(1)=cos(phi1+dphi)*rmax1*invcos
          x3(2)=sin(phi1+dphi)*rmax1*invcos
          x3(3)=z1
          
          x4(1)=cos(phi1+dphi)*rmax2*invcos
          x4(2)=sin(phi1+dphi)*rmax2*invcos
          x4(3)=z2


          n_old=n_inter_plane

          call in_quad(x,v,x1,x2,x3,x4,s_list_plane,n_inter_plane)


          
        endif


      do 20,j=1,npdv


          x1(1)=cos((j-1)*phi+phi1)*rmin1*invcos
          x1(2)=sin((j-1)*phi+phi1)*rmin1*invcos
          x1(3)=z1

          x2(1)=cos((j)*phi+phi1)*rmin1*invcos
          x2(2)=sin((j)*phi+phi1)*rmin1*invcos
          x2(3)=z1

          x3(1)=cos((j-1)*phi+phi1)*rmin2*invcos
          x3(2)=sin((j-1)*phi+phi1)*rmin2*invcos
          x3(3)=z2

          x4(1)=cos((j)*phi+phi1)*rmin2*invcos
          x4(2)=sin((j)*phi+phi1)*rmin2*invcos
          x4(3)=z2

          n_old=n_inter_plane

          call in_quad(x,v,x1,x2,x3,x4,s_list_plane,n_inter_plane)



          x1(1)=cos((j-1)*phi+phi1)*rmax1*invcos
          x1(2)=sin((j-1)*phi+phi1)*rmax1*invcos
          x1(3)=z1

          x2(1)=cos((j)*phi+phi1)*rmax1*invcos
          x2(2)=sin((j)*phi+phi1)*rmax1*invcos
          x2(3)=z1

          x3(1)=cos((j-1)*phi+phi1)*rmax2*invcos
          x3(2)=sin((j-1)*phi+phi1)*rmax2*invcos
          x3(3)=z2

          x4(1)=cos((j)*phi+phi1)*rmax2*invcos
          x4(2)=sin((j)*phi+phi1)*rmax2*invcos
          x4(3)=z2
 
          n_old=n_inter_plane

          call in_quad(x,v,x1,x2,x3,x4,s_list_plane,n_inter_plane)


20    continue



10    continue



      if (mod(n_inter_plane,2).ne.0) then
         print *,'n_inter_plane:',n_inter_plane
         print *,'x :',x(1),x(2),x(3)
         print *,'v :',v(1),v(2),v(3)
         do 38,i=1,4+3*nz
           print *,par_vol(ivol,i)
38       continue
         print *,'nz:',nz
      endif 
 
40    bubble=.false.

      do 50,i=1,n_inter_plane-1     
        if (s_list_plane(i).gt.s_list_plane(i+1)) then
          bubble=.true.
          call swapr(s_list_plane(i),s_list_plane(i+1))
        endif
50    continue

      if (bubble) goto 40

c     odd is in, even is out

      do 60,i=1,n_inter_plane
        if (s_list_plane(i).lt.1.0
     +             .and.s_list_plane(i).gt.0.0) then
          n_inter=n_inter+1
          s_list(n_inter)=s_list_plane(i)
          if (mod(i,2).eq.0) then
            in_out_list(n_inter)=-1
          else
            in_out_list(n_inter)=1
          endif 
        endif
60    continue


      return

      end











