*
* $Id: pgon_rmin_rmax.F,v 1.2 1995/08/29 13:28:55 zfiles Exp $
*
* $Log: pgon_rmin_rmax.F,v $
* Revision 1.2  1995/08/29 13:28:55  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : pgon_rmin_rmax
C     Purpose : Find extreme values of a pgon.
C     
C
C     Modifications:
C
C
C
      subroutine pgon_rmin_rmax(ivol,iwaf,rmin_w,rmax_w,
     +       phi_min,phi_max,zmin,zmax)


      implicit none

#include "klmn/klmnseq/vol.inc"
#include "klmn/klmnseq/wafer_n.inc"
#include "klmn/klmnseq/klmn_par.inc"


      real rmin_w,rmax_w
      real zmin,zmax,qzmin,qzmax
      real phi_min,phi_max,lphi_min,lphi_max

      real rmin,rmax,rmin1,rmin2,rmax1,rmax2,z1,z2,z
      real phi,phi1,dphi,qrmin,qrmax

      integer npdv    

      real s(4),in_out(4),vxy2,vx,q2,smin,lmin

   
      integer j,i,ivol,nz,n_old,iwaf

    
      real x1(3),x2(3),x3(3),x4(3)

      real xg1(3),xg2(3),xg3(3),xg4(3)


 
      
      if (abs(par_vol(ivol,4)*3+4-npar_vol(ivol)).gt.0.1) then
         print *,'In pgon_rmin_rmax'
         print *,'Paramter counting is wrong!'
      endif

      phi1=par_vol(ivol,1)*0.017453292
      dphi=par_vol(ivol,2)*0.017453292
      npdv=nint(par_vol(ivol,3))
      nz=nint(par_vol(ivol,4))
      phi=dphi/npdv

c     First do the ends.

      phi_min=16.3
      phi_max=-6.3
      rmin_w=10000.0
      rmax_w=0.0

      zmin=10000.0
      zmax=-10000.0

      z=par_vol(ivol,5)
      rmin=par_vol(ivol,6)
      rmax=par_vol(ivol,7)

      if (rmin.eq.rmax) goto 6

      if (rmin.lt.0.001) then
        print *,'In pgon_rmin_rmax'
        print *,'rmin to small:',rmin
        rmin=0.001
      endif

      do 8,j=1,npdv

        x1(1)=cos((j-1)*phi+phi1)*rmin/cos(phi/2)
        x1(2)=sin((j-1)*phi+phi1)*rmin/cos(phi/2)
        x1(3)=z

        x2(1)=cos((j)*phi+phi1)*rmin/cos(phi/2)
        x2(2)=sin((j)*phi+phi1)*rmin/cos(phi/2)
        x2(3)=z

        x3(1)=cos((j-1)*phi+phi1)*rmax/cos(phi/2)
        x3(2)=sin((j-1)*phi+phi1)*rmax/cos(phi/2)
        x3(3)=z

        x4(1)=cos((j)*phi+phi1)*rmax/cos(phi/2)
        x4(2)=sin((j)*phi+phi1)*rmax/cos(phi/2)
        x4(3)=z

      call transform(iwaf,x1,xg1)
      call transform(iwaf,x2,xg2)
      call transform(iwaf,x3,xg3)
      call transform(iwaf,x4,xg4)

      call quad_rmin_rmax(xg1,xg2,xg3,xg4,qrmin,qrmax,
     +      lphi_min,lphi_max,qzmin,qzmax)

      zmin=min(zmin,qzmin)
      zmax=max(zmax,qzmax)

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)

      rmin_w=min(rmin_w,qrmin)
      rmax_w=max(rmax_w,qrmax)
        

8     continue      

6     continue 

c      print *,'Inter in ends:',n_inter_plane

c      if (n_inter_plane.ne.0) then 
c
c        print *,'x  :',x(1),x(2),x(3)
c        print *,'xto:',xto(1),xto(2),xto(3)
c        print *,'x1 :',x1(1),x1(2),x1(3)
c        print *,'x2 :',x2(1),x2(2),x2(3)
c        print *,'x3 :',x3(1),x3(2),x3(3)
c        print *,'x4 :',x4(1),x4(2),x4(3)
c        print *,'phi,dphi,npdv:',phi,dphi,npdv
c        print *,'rmin,rmax:',rmin,rmax
c      endif

      z=par_vol(ivol,(nz-1)*3+5)
      rmin=par_vol(ivol,(nz-1)*3+6)
      rmax=par_vol(ivol,(nz-1)*3+7)

      if (rmin.eq.rmax) goto 9

      if (rmin.lt.0.001) then
        print *,'In pgon_intercept'
        print *,'rmin to small:',rmin
        rmin=0.001
      endif

      do 7,j=1,npdv

        x1(1)=cos((j-1)*phi+phi1)*rmin/cos(phi/2)
        x1(2)=sin((j-1)*phi+phi1)*rmin/cos(phi/2)
        x1(3)=z

        x2(1)=cos((j)*phi+phi1)*rmin/cos(phi/2)
        x2(2)=sin((j)*phi+phi1)*rmin/cos(phi/2)
        x2(3)=z

        x3(1)=cos((j-1)*phi+phi1)*rmax/cos(phi/2)
        x3(2)=sin((j-1)*phi+phi1)*rmax/cos(phi/2)
        x3(3)=z

        x4(1)=cos((j)*phi+phi1)*rmax/cos(phi/2)
        x4(2)=sin((j)*phi+phi1)*rmax/cos(phi/2)
        x4(3)=z

      call transform(iwaf,x1,xg1)
      call transform(iwaf,x2,xg2)
      call transform(iwaf,x3,xg3)
      call transform(iwaf,x4,xg4)

      call quad_rmin_rmax(xg1,xg2,xg3,xg4,qrmin,qrmax,
     +      lphi_min,lphi_max,qzmin,qzmax)

      zmin=min(zmin,qzmin)
      zmax=max(zmax,qzmax)
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)

      rmin_w=min(rmin_w,qrmin)
      rmax_w=max(rmax_w,qrmax)

7     continue      

c       if (n_inter_plane.gt.0) then
c         Print *,'Will do main:',n_inter_plane
c       endif

c     Now do the main areas

9     continue


      do 10,i=1,nz-1

        z1=par_vol(ivol,2+i*3)
        z2=par_vol(ivol,5+i*3)
        rmin1=par_vol(ivol,3+i*3)
        rmin2=par_vol(ivol,6+i*3)
        rmax1=par_vol(ivol,4+i*3)
        rmax2=par_vol(ivol,7+i*3)

        if (rmin1.lt.0.001) then
          print *,'In pgon_intercept'
          print *,'rmin1 to small:',rmin1
          rmin1=0.001
        endif

        if (rmin2.lt.0.001) then
          print *,'In pgon_intercept'
          print *,'rmin2 to small:',rmin2
          rmin2=0.001
        endif


        if (z1.eq.z2) then
          PRint *,'z1=z2 not implemented in pgon_intercept;'
        endif

        if (dphi.lt.359.0) then

          x1(1)=cos(phi1)*rmin1/cos(phi/2)
          x1(2)=sin(phi1)*rmin1/cos(phi/2)
          x1(3)=z1
          
          x2(1)=cos(phi1)*rmin2/cos(phi/2)
          x2(2)=sin(phi1)*rmin2/cos(phi/2)
          x2(3)=z2
          
          x3(1)=cos(phi1)*rmax1/cos(phi/2)
          x3(2)=sin(phi1)*rmax1/cos(phi/2)
          x3(3)=z1
          
          x4(1)=cos(phi1)*rmax2/cos(phi/2)
          x4(2)=sin(phi1)*rmax2/cos(phi/2)
          x4(3)=z2


      call transform(iwaf,x1,xg1)
      call transform(iwaf,x2,xg2)
      call transform(iwaf,x3,xg3)
      call transform(iwaf,x4,xg4)

      call quad_rmin_rmax(xg1,xg2,xg3,xg4,qrmin,qrmax,
     +      lphi_min,lphi_max,qzmin,qzmax)

      zmin=min(zmin,qzmin)
      zmax=max(zmax,qzmax)
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)

      rmin_w=min(rmin_w,qrmin)
      rmax_w=max(rmax_w,qrmax)

c          if (n_inter_plane.eq.1.and.n_old.eq.0) then
c            print *,'Pphi1 i:',i
c          endif         


          
          x1(1)=cos(phi1+dphi)*rmin1/cos(phi/2)
          x1(2)=sin(phi1+dphi)*rmin1/cos(phi/2)
          x1(3)=z1
          
          x2(1)=cos(phi1+dphi)*rmin2/cos(phi/2)
          x2(2)=sin(phi1+dphi)*rmin2/cos(phi/2)
          x2(3)=z2
          
          x3(1)=cos(phi1+dphi)*rmax1/cos(phi/2)
          x3(2)=sin(phi1+dphi)*rmax1/cos(phi/2)
          x3(3)=z1
          
          x4(1)=cos(phi1+dphi)*rmax2/cos(phi/2)
          x4(2)=sin(phi1+dphi)*rmax2/cos(phi/2)
          x4(3)=z2



      call transform(iwaf,x1,xg1)
      call transform(iwaf,x2,xg2)
      call transform(iwaf,x3,xg3)
      call transform(iwaf,x4,xg4)

      call quad_rmin_rmax(xg1,xg2,xg3,xg4,qrmin,qrmax,
     +      lphi_min,lphi_max,qzmin,qzmax)

      zmin=min(zmin,qzmin)
      zmax=max(zmax,qzmax)
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)

      rmin_w=min(rmin_w,qrmin)
      rmax_w=max(rmax_w,qrmax)

c          if (n_inter_plane.eq.1.and.n_old.eq.0) then
c            print *,'Pphi1+dphi i:',i
c          endif         


          
        endif


      do 20,j=1,npdv


          x1(1)=cos((j-1)*phi+phi1)*rmin1/cos(phi/2)
          x1(2)=sin((j-1)*phi+phi1)*rmin1/cos(phi/2)
          x1(3)=z1

          x2(1)=cos((j)*phi+phi1)*rmin1/cos(phi/2)
          x2(2)=sin((j)*phi+phi1)*rmin1/cos(phi/2)
          x2(3)=z1

          x3(1)=cos((j-1)*phi+phi1)*rmin2/cos(phi/2)
          x3(2)=sin((j-1)*phi+phi1)*rmin2/cos(phi/2)
          x3(3)=z2

          x4(1)=cos((j)*phi+phi1)*rmin2/cos(phi/2)
          x4(2)=sin((j)*phi+phi1)*rmin2/cos(phi/2)
          x4(3)=z2


      call transform(iwaf,x1,xg1)
      call transform(iwaf,x2,xg2)
      call transform(iwaf,x3,xg3)
      call transform(iwaf,x4,xg4)

      call quad_rmin_rmax(xg1,xg2,xg3,xg4,qrmin,qrmax,
     +      lphi_min,lphi_max,qzmin,qzmax)

      zmin=min(zmin,qzmin)
      zmax=max(zmax,qzmax)
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)

      rmin_w=min(rmin_w,qrmin)
      rmax_w=max(rmax_w,qrmax)

c          if (n_inter_plane.eq.1.and.n_old.eq.0) then
c            print *,'Inner i,j:',i,j
c          endif         


          x1(1)=cos((j-1)*phi+phi1)*rmax1/cos(phi/2)
          x1(2)=sin((j-1)*phi+phi1)*rmax1/cos(phi/2)
          x1(3)=z1

          x2(1)=cos((j)*phi+phi1)*rmax1/cos(phi/2)
          x2(2)=sin((j)*phi+phi1)*rmax1/cos(phi/2)
          x2(3)=z1

          x3(1)=cos((j-1)*phi+phi1)*rmax2/cos(phi/2)
          x3(2)=sin((j-1)*phi+phi1)*rmax2/cos(phi/2)
          x3(3)=z2

          x4(1)=cos((j)*phi+phi1)*rmax2/cos(phi/2)
          x4(2)=sin((j)*phi+phi1)*rmax2/cos(phi/2)
          x4(3)=z2
 
          
      call transform(iwaf,x1,xg1)
      call transform(iwaf,x2,xg2)
      call transform(iwaf,x3,xg3)
      call transform(iwaf,x4,xg4)

      call quad_rmin_rmax(xg1,xg2,xg3,xg4,qrmin,qrmax,
     +      lphi_min,lphi_max,qzmin,qzmax)

      zmin=min(zmin,qzmin)
      zmax=max(zmax,qzmax)
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)

      rmin_w=min(rmin_w,qrmin)
      rmax_w=max(rmax_w,qrmax)

c          if (n_inter_plane.eq.1.and.n_old.eq.0) then
c            print *,'Outer i,j:',i,j
c          endif         

20    continue

10    continue

      if (phi_min.gt.klmn_twopi) then
             phi_min=phi_min-klmn_twopi
             phi_max=phi_max-klmn_twopi
      endif

      if (phi_max-phi_min.gt.2.0) then 
         print *,'problem in pgon_rmin_rmax'
         print *,'phi_max,phi_min:',phi_max,phi_min
      endif
         
    

      return

      end











