*
* $Id: quad_rmin_rmax.F,v 1.2 1995/08/29 13:28:56 zfiles Exp $
*
* $Log: quad_rmin_rmax.F,v $
* Revision 1.2  1995/08/29 13:28:56  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : quad_rmin_rmax
C     Purpose : Find extreme values of a four cornered plane
C               area.
C     
C
C     Modifications:
C
C
C
      subroutine quad_rmin_rmax(x1,x2,x3,x4,rmin,rmax,
     +       phi_min,phi_max,zmin,zmax)

      implicit none

#include "klmn/klmnseq/klmn_par.inc"

      real x1(3),x2(3),x3(3),x4(3)
      real rmin,rmax,phi_min,phi_max,zmin,zmax

      real lrmin,lrmax,lphi_min,lphi_max

      phi_min=6.3
      phi_max=-6.3
 
      zmin=10000.0
      zmax=-10000.0

      rmin=10000.0
      rmax=0.0

      zmin=min(zmin,x1(3))
      zmin=min(zmin,x2(3))
      zmin=min(zmin,x3(3))
      zmin=min(zmin,x4(3))

      zmax=max(zmax,x1(3))
      zmax=max(zmax,x2(3))
      zmax=max(zmax,x3(3))
      zmax=max(zmax,x4(3))

      call line_rmin_rmax(x1(1),x1(2),x2(1)-x1(1),
     +                   x2(2)-x1(2),lrmin,lrmax,
     +                   lphi_min,lphi_max)

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)
      rmin=min(rmin,lrmin)
      rmax=max(rmax,lrmax)


      call line_rmin_rmax(x1(1),x1(2),x3(1)-x1(1),
     +                   x3(2)-x1(2),lrmin,lrmax,
     +                   lphi_min,lphi_max)

   
      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)

      rmin=min(rmin,lrmin)
      rmax=max(rmax,lrmax)


      call line_rmin_rmax(x4(1),x4(2),x2(1)-x4(1),
     +                   x2(2)-x4(2),lrmin,lrmax,
     +                   lphi_min,lphi_max)

      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)

      rmin=min(rmin,lrmin)
      rmax=max(rmax,lrmax)


      call line_rmin_rmax(x4(1),x4(2),x3(1)-x4(1),
     +                   x3(2)-x4(2),lrmin,lrmax,
     +                   lphi_min,lphi_max)

      if (lphi_min-phi_min.lt.-3) then
        lphi_min=lphi_min+klmn_twopi
        lphi_max=lphi_max+klmn_twopi
      elseif (phi_min-lphi_min.lt.-3) then
        phi_min=phi_min+klmn_twopi
        phi_max=phi_max+klmn_twopi
      endif

      phi_min=min(phi_min,lphi_min)
      phi_max=max(phi_max,lphi_max)

      rmin=min(rmin,lrmin)
      rmax=max(rmax,lrmax)

      if (phi_min.gt.6.29) then 
        print *,'phi_min:',phi_min
      endif

      if (phi_max-phi_min.gt.2.0) then
         print *,'phi_max,phi_min:',phi_max,phi_min
      endif

c      print *,phi_min,phi_max

      return

      end




