*
* $Id: trd1_intercept.F,v 1.2 1995/08/29 13:29:06 zfiles Exp $
*
* $Log: trd1_intercept.F,v $
* Revision 1.2  1995/08/29 13:29:06  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : trd1_intercept
C     Purpose : Finds the intercept of the straight line from
C               x1s to x2s with the trd1 volume.
C     
C
C     Modifications:
C
C
C


      subroutine trd1_intercept(s_list,in_out_list,n_entries,
     +                            dx1s,dx2s,dys,dzs,x1s,x2s)

      implicit none

      integer in_out_list(4),n_entries,n_entries_temp,i
      real s_list_temp(4)

      real s_list(4),dx1s,dx2s,dys,dzs,x1s(3),x2s(3)
      real*8 dx1,dx2,dy,dz,x1(3),x2(3)
      real*8 xl,yl,zl,s,a,b

      logical in_1,in_2
   

      real*8 v(3)

      dx1=dx1s
      dx2=dx2s
      dy=dys
      dz=dzs

      x2(1)=x2s(1)
      x2(2)=x2s(2)
      x2(3)=x2s(3)

      x1(1)=x1s(1)
      x1(2)=x1s(2)
      x1(3)=x1s(3)

      v(1)=x2(1)-x1(1)
      v(2)=x2(2)-x1(2)
      v(3)=x2(3)-x1(3)

      n_entries=0
      n_entries_temp=0

      a=(dx2-dx1)/(2*dz)
      b=dx1+a*dz
      if (v(1)-a*v(3).eq.0.0) goto 10
      s=(a*x1(3)+b-x1(1))/(v(1)-a*v(3))
      xl=x1(1)+s*v(1)
      yl=x1(2)+s*v(2)
      zl=x1(3)+s*v(3)

      if (abs(zl).gt.dz) goto 10
      if (abs(yl).gt.dy) goto 10
      
      n_entries_temp=n_entries_temp+1

      s_list_temp(n_entries_temp)=s

10    continue
      a=-(dx2-dx1)/(2*dz)
      b=-dx1+a*dz
      if (v(1)-a*v(3).eq.0.0) goto 20
      s=(a*x1(3)+b-x1(1))/(v(1)-a*v(3))
      xl=x1(1)+s*v(1)
      yl=x1(2)+s*v(2)
      zl=x1(3)+s*v(3)

      if (abs(zl).gt.dz) goto 20
      if (abs(yl).gt.dy) goto 20
      
      n_entries_temp=n_entries_temp+1

      s_list_temp(n_entries_temp)=s

20    continue

      if (v(3).eq.0.0) goto 30

      s=(dz-x1(3))/v(3)
      xl=x1(1)+s*v(1)
      yl=x1(2)+s*v(2)
      zl=x1(3)+s*v(3)
      if (abs(yl).gt.dy) goto 30
      if (abs(xl).gt.dx2) goto 30
      n_entries_temp=n_entries_temp+1
      s_list_temp(n_entries_temp)=s

30    continue

      if (v(3).eq.0.0) goto 40

      s=(-dz-x1(3))/v(3)
      xl=x1(1)+s*v(1)
      yl=x1(2)+s*v(2)
      zl=x1(3)+s*v(3)
      if (abs(yl).gt.dy) goto 40
      if (abs(xl).gt.dx1) goto 40
c      if (abs(xl).gt.dx1+(dx2-dx1)*(yl+dy)/(2.0*dy)) goto 40
      n_entries_temp=n_entries_temp+1
      s_list_temp(n_entries_temp)=s

40    continue

      if (v(2).eq.0.0) goto 50

      s=(dy-x1(2))/v(2)
      xl=x1(1)+s*v(1)
      yl=x1(2)+s*v(2)
      zl=x1(3)+s*v(3)
      if (abs(zl).gt.dz) goto 50
      if (abs(xl).gt.dx1+(dx2-dx1)*(zl+dz)/(2.0*dz)) goto 50
      n_entries_temp=n_entries_temp+1
      s_list_temp(n_entries_temp)=s

50    continue

      if (v(2).eq.0.0) goto 60

      s=(-dy-x1(2))/v(2)
      xl=x1(1)+s*v(1)
      yl=x1(2)+s*v(2)
      zl=x1(3)+s*v(3)
      if (abs(zl).gt.dz) goto 60
      if (abs(xl).gt.dx1+(dx2-dx1)*(zl+dz)/(2.0*dz)) goto 60
      n_entries_temp=n_entries_temp+1
      s_list_temp(n_entries_temp)=s

60    continue

      if (n_entries_temp.eq.0) goto 999

      if (n_entries_temp.eq.1.or.
     +    n_entries_temp.gt.2) then
        print *,'In trd1_intercept:',n_entries_temp
      endif

      if (s_list_temp(1).gt.s_list_temp(2)) 
     +     call swapr(s_list_temp(1),s_list_temp(2))

      do 160,i=1,n_entries_temp
        if (s_list_temp(i).lt.1.0
     +             .and.s_list_temp(i).gt.0.0) then
          n_entries=n_entries+1
          s_list(n_entries)=s_list_temp(i)
          if (mod(i,2).eq.0) then
            in_out_list(n_entries)=-1
          else
            in_out_list(n_entries)=1
          endif 
        endif
160    continue
      

999   continue

      return

      end






