*
* $Id: waf_rmin_rmax.F,v 1.2 1995/08/29 13:29:11 zfiles Exp $
*
* $Log: waf_rmin_rmax.F,v $
* Revision 1.2  1995/08/29 13:29:11  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : waf_rmin_rmax
C     Purpose : finds the extrem values of a wafer volume
C     
C
C     Modifications:
C
C
C
      subroutine waf_rmin_rmax(iwaf,rmin,rmax,
     +           phi_min,phi_max,zmin,zmax)

      implicit none

      real rmin,rmax,phi_min,phi_max,zmin,zmax
      integer iwaf,ivol

#include "klmn/klmnseq/wafer_n.inc"
#include "klmn/klmnseq/vol.inc"
#include "klmn/klmnseq/klmn_par.inc"

      ivol=vol_num_waf(iwaf)
      
      if (vol_is(ivol).eq.is_box) then

         call box_rmin_rmax(ivol,iwaf,rmin,rmax,
     +      phi_min,phi_max,zmin,zmax)

      elseif (vol_is(ivol).eq.is_trd1) then

         call trd1_rmin_rmax(ivol,iwaf,rmin,rmax,
     +      phi_min,phi_max,zmin,zmax)

      elseif (vol_is(ivol).eq.is_para) then

         call para_rmin_rmax(ivol,iwaf,rmin,rmax,
     +      phi_min,phi_max,zmin,zmax)

      elseif (vol_is(ivol).eq.is_pgon) then

         call pgon_rmin_rmax(ivol,iwaf,rmin,rmax,
     +      phi_min,phi_max,zmin,zmax)

      elseif (vol_is(ivol).eq.is_tube) then

         call tube_rmin_rmax(ivol,iwaf,rmin,rmax,
     +      phi_min,phi_max,zmin,zmax)

      else 
 
        print *,'Volume type:',vol_type(ivol),
     +          ' not implemented in waf_rmin_rmax'
 
        rmin=0.0
        rmax=10000.0

        zmin=-10000.0
        zmax=10000

        phi_min=0.0
        phi_max=klmn_twopi

      endif

      return

      end

