*
* $Id: klmncm.inc,v 1.2 1995/08/29 13:29:38 zfiles Exp $
*
* $Log: klmncm.inc,v $
* Revision 1.2  1995/08/29 13:29:38  zfiles
* Complete new set from Rob/Anders. Id and Log added
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : klmncm.inc
C     Purpose : Holds smoothed information at each hit in the fit.
C     
C
C     Modifications:
C
C
C
C
C

C      Maximum number of points that can be used in fit

       integer maxfit
       parameter(maxfit=200)

c      The variables eta_s and veta_s are after the invard
c      pass of the fit filled with the current estimates
c      of the parameters and the variance matrix.
c      After a smoothing pass it is filled with the best
c      estimate using both invard and outward information 
c      at that point. x_s,y_s,z_s are the origin of the
c      coordinate system used. (The _s means smoothing)

       real eta_s
       real*8 veta_s

       real x_s,y_s,z_s,res_s,sigma2_s

       logical used_in_fit

c      k_kl,d0_kl,phi_kl,z_kl,t_kl are after the inward (and
c      outward ) pass filled with the current best estimates
c      at the point of closest approach v_kl contains the
c      estimated varians matrix


       common /klmncm_l/
     +         used_in_fit(maxfit)


       common /klmncm_r/
     +         eta_s(5,maxfit),
     +         veta_s(5,5,maxfit),
     +         x_s(maxfit),y_s(maxfit),z_s(maxfit),
     +         res_s(maxfit),sigma2_s(maxfit)
